/*
	
	Basic UI functions
	
*/

var ui =
{
	
	alert : function(message)
	{
		cyclone3xuladmin.core.log.append('alert: ' + message);
	},
	
	locale :
	{
		get : function()
		{
			try
			{
				//log('ui.locale.get')
				ui.locale.chrome=[];
				var tmpBundle = ui.locale.stringBundle.get("chrome://c3xuladmin/locale/stringlist.properties");
				if(tmpBundle){ui.locale.string=tmpBundle}
				else {alert('[ui.js] {locale.get} could not load interface language for your locale!')}
				
				if (window.arguments) 
				{
					if (window.arguments[0]) 
					{
						if (window.arguments[0]['chromes'])
						{
							var chromes = window.arguments[0]['chromes'];
							for (var chrome in chromes)
							{
								if (
									(chrome != 'keyAttributes') &&
									(chrome != 'keyValue')
								)
								{
								
								//log('load strings from chrome='+chrome)
								//????
								var tmpBundle = ui.locale.stringBundle.get("chrome://" + chromes[chrome] + "/locale/stringlist.properties");
								if(tmpBundle){ui.locale.chrome[chrome]=tmpBundle}
								else {alert('[ui.js] {locale.get} could not load interface language for your locale!')}

								}
							}
						}	
					}
				}
				
			}catch(e){alert("[ui.js] {locale.get} " + e)}
		},
		getStringFromName : function (stringName)
		{
			try
			{
				//log('getStringFromName='+stringName);
				return ui.locale.string.GetStringFromName(stringName)
			}
			catch(e)
			{
				for (var chrome in window.arguments[0]['chromes'])
				{
					if (
						(chrome != 'keyAttributes') &&
						(chrome != 'keyValue')
					)
					{
						try
						{
							//log('trying string from chrome='+chrome);
							return ui.locale.chrome[chrome].GetStringFromName(stringName)
						}
						catch(e)
						{
						}
					}
				}
				return stringName
			}
			return ""
		},
		stringBundle :
		{
			get : function(stringBundlePath)
			{
				try
				{
					
					var localeService =
						Components
						.classes["@mozilla.org/intl/nslocaleservice;1"]
						.getService(Components.interfaces.nsILocaleService);
					
					var appLocale =  localeService.getApplicationLocale();
					
					var stringBundleService =
						Components.classes["@mozilla.org/intl/stringbundle;1"]
						.getService(Components.interfaces.nsIStringBundleService);
					
					return stringBundleService.createBundle(stringBundlePath, appLocale);
					
				}catch(e){alert("[ui.js] {locale.stringBundle.get} " + e);}
				return false;
			},
		},
		strings : null
	},
	
	menulist : {
		
		create: function(e4x, fncSetup)
		{
			var tmpXulObject
			
			tmpXulObject = document.createElement('menulist');
			
			var tmpXulMenupopup = tmpXulObject.appendChild(document.createElement('menupopup'));
			
			if(fncSetup.addBlankRecord)
			{
				var tmpItemNode = document.createElement('menuitem')
				
				tmpItemNode.setAttribute('IDitem', "")
				tmpItemNode.setAttribute('label', "")
				tmpItemNode.value=""
				
				tmpItemNode = tmpXulMenupopup.appendChild(tmpItemNode)
			}
			
			var e4x_item = e4x.item;
			for (var item in e4x_item)
			{
				if(e4x_item[item][fncSetup.var_active] == 'N' && fncSetup.var_allow!=e4x_item[item][fncSetup.var_value])
				{
					continue;
				}
				
				var tmpItemNode = document.createElement('menuitem')
				
				tmpItemNode.setAttribute('label', e4x_item[item][fncSetup.var_label])
				tmpItemNode.setAttribute('value', e4x_item[item][fncSetup.var_value])
				tmpItemNode.setAttribute('is_default', e4x_item[item][fncSetup.var_is_default])
				tmpItemNode.value=e4x_item[item][fncSetup.var_value]
				
				log('setting value '+e4x_item[item][fncSetup.var_value]+' for menuitem '+e4x_item[item][fncSetup.var_label])
				
				tmpItemNode = tmpXulMenupopup.appendChild(tmpItemNode)
			}
			
			return tmpXulObject
			
		}
	},
	
	lng : function (lang)
	{
		if (lang)
		{
			this.lng_internal = lang;
			return lang;
		}
		else if (this.lng_internal)
		{
			return this.lng_internal;
		}
		
		else if (window.arguments[1])
		{
			if (window.arguments[1].lng)
			{
				this.lng_internal = window.arguments[1].lng + '';
				return window.arguments[1].lng + '';
			}
		}
		
		if (Cyclone3.domain)
		{
			if (Cyclone3.domain['languages'])
			{
				if (Cyclone3.domain['languages']['@default'])
				{
					this.lng_internal = Cyclone3.domain['languages']['@default'] + '';
					return Cyclone3.domain['languages']['@default'] + '';
				}
			}
		}
		
		return;
	},
	
	localDate: function (date_string)
	{
		return date_string.replace(/(\d{4})-(\d{2})-(\d{2})/g, "$3.$2.$1");
	},

	saveColumnLayout: function (binding_name, tree_element)
	{
		try{
			var i = tree_element.columns.length;
								
			var column_hash = {};
				
			for (var j=0; j<i; j++)
			{
				var one_column = {};
				one_column['id'] = tree_element.columns[j].id;
				one_column['width'] = tree_element.columns[j].width;
				one_column['hidden'] = tree_element.columns[j].element.hidden;
						
				column_hash[tree_element.columns[j].id] = one_column;
			}
			
			if (! window.arguments[0].col_hash)
			{
				window.arguments[0].col_hash = {};
			}
			window.arguments[0].col_hash[binding_name] = column_hash;
			ui.writeColumnLayoutToDisk();

		}catch(e){alert("[ui.js] {saveColumnLayout} " + e);}
	},

	loadColumnLayout: function (binding_name, tree_element)
	{
		try{
			/* alert('loadcolumnlayout name: ' + binding_name + ' element: ' + tree_element.tagName); */
			
			if (window.arguments[0].col_hash)
			{
				var col_hash = window.arguments[0].col_hash[binding_name];
			}
			
				
			for (var i in col_hash)
			{
				if (tree_element.columns[i])
				{
					tree_element.columns[i].element.hidden = col_hash[i]['hidden'];
					tree_element.columns[i].element.width = col_hash[i]['width'];
				}
			}

		/* after column states have been loaded, we can register the listeners */
					
		var treeCols = tree_element.getElementsByTagNameNS('http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul','treecols');
		if (treeCols)
		{
			for (var i = 0; i< treeCols.length; i++)
			{
				treeCols[i].addEventListener('click', function(e){
					if (e.originalTarget.parentElement.parentElement.localName == 'treecolpicker') { // nasty way to detect columnpicker click
						// hack to get correct values as click is triggered before actual attribute changes, otherwise we would get previous values
						setTimeout(function(){ ui.saveColumnLayout(binding_name, tree_element); }, 500);
					}
				}, true);
			}
			var children = treeCols[0];
			if (children)
			{
				var splitters = children.getElementsByTagNameNS('http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul','splitter');
				
				/* now let's get all the column splitters for this tree and hook 'command' event 
				   listeners to it  */

				/*
					NOTE: this is actually not very wise. Many event listeners may cause the UI to be 
					less responsive and slower. Furthermore we are not checking events where the user makes
					column(s) visible/invisible, only splitter-affected changes.
				*/
				
				if (splitters)
				{
					for (var i = 0; i< splitters.length; i++)
					{
						splitters[i].addEventListener('command', function(){ui.saveColumnLayout(binding_name, tree_element);}, true);
					}
				}
			}
		}
		}catch(e){alert("[ui.js] {loadColumnLayout} " + e);}
	},

	writeColumnLayoutToDisk: function ()
	{
		try{
			if (window.arguments[0].col_hash)
			{
				
				var json_string = JSON.stringify(window.arguments[0].col_hash);
				var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);

				const MODE_WRONLY = 0x2;
				const MODE_CREATE = 0x8;
				const MODE_TRUNCATE = 0x20;
				
				file.initWithPath(ui.toProfileDir('c3xuladmin.columns.json'));
   				var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
   				foStream.init(file, MODE_WRONLY | MODE_CREATE | MODE_TRUNCATE, parseInt("0666", 8), 0);
				var converter = Components.classes["@mozilla.org/intl/converter-output-stream;1"].createInstance(Components.interfaces.nsIConverterOutputStream);  
   				converter.init(foStream, "UTF-8", 0, 0);converter.writeString(json_string);converter.close();
			} else 
			{
				
			}

		}catch(e){alert("[ui.js] {writeColumnLayoutToDisk} " + e);}
	},

	loadColumnLayoutFromDisk: function ()
	{
		try{
			var json_string = '';
			var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			file.initWithPath(ui.toProfileDir('c3xuladmin.columns.json'));
			
			Components.utils.import("resource://gre/modules/FileUtils.jsm").FileUtils;
			Components.utils.import("resource://gre/modules/NetUtil.jsm");
			// var nsifile   = new FileUtils.File( fileName );
			var channel = NetUtil.newChannel(file);

			channel.contentType = "application/json";

			NetUtil.asyncFetch(channel, function(inputStream, status) {
			  if (!Components.isSuccessCode(status)) {
			     // Handle error!
			     console.log('error reading file, status:',status);
			     return;
			   }

			   // The file data is contained within inputStream.
			   // You can read it into a string with
			   var data = NetUtil.readInputStreamToString(inputStream, inputStream.available());

			   var my_hash = JSON.parse(data);
			   
			   window.arguments[0].col_hash = my_hash;
			});
			
		}catch(e){
			log("[ui.js] {loadColumnLayoutFromDisk} " + e);
		}
	},

	toProfileDir: function (savefile)
	{
		try{
			var path;
			const DIR_SERVICE = new Components.Constructor("@mozilla.org/file/directory_service;1","nsIProperties");
			try { 
				path=(new DIR_SERVICE()).get("ProfD", Components.interfaces.nsIFile).path; 
			} catch (e) { return; }

			if (path.search(/\\/) != -1) { path = path + "\\"; } else { path = path + "/"; }

			return path+savefile;

		}catch(e){alert("[ui.js] {toProfileDir} " + e);}
	},

	probeOpenWindow: function (id)
	{
		// find the first open window with the specified id. return that window or false
		try{

			var ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
			.getService(Components.interfaces.nsIWindowWatcher);

			var winlist = ww.getWindowEnumerator();

			while (winlist.hasMoreElements())
			{
				var win = winlist.getNext();
				var win_id = win.document.documentElement.id;

				if (win_id == id)
				{
					return win;
				}
			}
			
			return false;

		}catch(e){alert("[ui.js] {probeOpenWindow} " + e);}
	},
	
	elmsOverlap: function(cx, cy, cw, ch, bx, by, bw, bh)
	{
		try {
			// awful if to detect if elements overlap
			if ((((cx >= bx && cx <= bx + bw) || (cx + cw >= bx && cx + cw <= bx + bw)) && 
						((cy >= by && cy <= by + bh) || (cy + ch >= by && cy + ch <= by + bh))) || 
						(((bx >= cx && bx <= cx + cw) || (bx + bw >= cx && bx + bw <= cx + cw)) && 
						((by >= cy && by <= cy + ch) || (by + bh >= cy && by + bh <= cy + ch))) ||
						(((bx >= cx && bx <= cx + cw) || (bx + bw >= cx && bx + bw <= cx + cw)) &&
						((cy >= by && cy <= by + bh) || (cy + ch >= by && cy + ch <= by + bh))) || 
						(((cx >= bx && cx <= bx + bw) || (cx + cw >= bx && cx + cw <= bx + bw)) &&
						((by >= cy && by <= cy + ch) || (by + bh >= cy && by + bh <= cy + ch))))
			{
				return true;
			}
			
			return false;
			
		}catch(e){alert("[ui.js] {elmsOverlap} " + e);}
	},
	
	loading_feedback: function(container, start)
	{
		if (start)
		{
			container.setAttribute('busy','true');
		}
		else
		{
			container.removeAttribute('busy');
		}
	}
};

function alert(message)
{
	ui.alert(message);
	window.openDialog(
		'chrome://c3xuladmin/content/alert.xul',
		'cyclone-dialog',
		'chrome,centerscreen,modal,outerWidth=400,outerHeight=180',
		message
	);
}

ui.locale.get();
