<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	
	<xsl:output	
		method="text" encoding="utf-8" indent="yes"
	/>
	
	<xsl:template match="/">
	
	<xsl:for-each select="/*/row">
BEGIN:VCARD
VERSION:3.0
<xsl:choose>
	<xsl:when test="contains(name,', ')">N:<xsl:value-of select="substring-before(name,', ')" />;<xsl:value-of select="substring-after(name,', ')"/>
	</xsl:when>
	<xsl:when test="contains(name,',')">N:<xsl:value-of select="substring-before(name,',')" />;<xsl:value-of select="substring-after(name,',')"/>
	</xsl:when>
	<xsl:otherwise>N:<xsl:value-of select="child::name"/>
	</xsl:otherwise>
</xsl:choose>
FN:<xsl:value-of select="child::name"/>

<xsl:if test="organizations!=''">
ORG:<xsl:value-of select="child::organizations"/>
</xsl:if>

<xsl:if test="street!='' or street_num!='' or city!='' or ZIP!=''">
ADR:;;<xsl:value-of select="child::street"/> <xsl:value-of select="child::street_num"/>;<xsl:value-of select="child::city"/>;<xsl:value-of select="child::ZIP"/>
</xsl:if>

<xsl:if test="phone_mobile!=null">
TEL;TYPE=cell,voice:<xsl:value-of select="child::phone_mobile"/>
</xsl:if>

<xsl:if test="email!=''">
EMAIL;TYPE=pref,internet:<xsl:value-of select="child::email"/>
</xsl:if>

<xsl:if test="note!=''">
NOTE:<xsl:value-of select="child::note"/>
</xsl:if>
END:VCARD
</xsl:for-each>
	
	</xsl:template>
	
</xsl:stylesheet>

